import PouchFactory from './pouches/factory/PouchFactory';
import {
  ClassConstructor,
} from './pouches/constants';

class AppContext {
  private static _instance: AppContext;
  private _pouchFactory: PouchFactory;

  public constructor() {
    this._pouchFactory = new PouchFactory();
  }

  public get PouchFactory(): PouchFactory {
    return this._pouchFactory;
  }

  /**
   * getPouch
   */
  public getPouch<T>(type: ClassConstructor<T>, ...args: any[]): T {
    return this._pouchFactory.getPouch(type, args);
  }

  /**
   * getPouchByQualifier
   */
  public getPouchByQualifier<T>(type: ClassConstructor<T>, qualifier: string | symbol, ...args: any[]): T {
    return this._pouchFactory.getPouchByQualifier(type, qualifier, args);
  }

  public destroy(): void {
    console.log('AppContext has been destroyed.');
  }

  public static getInstance(): AppContext {
    if (undefined === AppContext._instance) {
      AppContext._instance = new AppContext();
    }
    return AppContext._instance;
  }
}

export default AppContext;
