import { PouchScope, POUCH_DEFAULT_QUALIFIER } from '../constants';

class PouchDefinition {
  protected _type: Function;
  protected _scope: PouchScope = PouchScope.SINGLETON;
  protected _qualifier: string | symbol;
  protected _postConstruct: string[] = null;
  protected _preDestroy: string[] = null;

  public constructor(type: Function) {
    this._type = type;
    this._qualifier = POUCH_DEFAULT_QUALIFIER;
  }

  public get type(): Function {
      return this._type;
  }

  public get scope(): PouchScope {
      return this._scope;
  }

  public set scope(scope: PouchScope) {
    this._scope = scope;
  }

  public get qualifier(): string | symbol {
      return this._qualifier;
  }

  public set qualifier(qualifier: string | symbol) {
    this._qualifier = qualifier;
  }

  public get postConstruct(): string[] {
      return this._postConstruct;
  }

  public addPostConstruct(postConstruct: string): void {
    if (null == this._postConstruct) {
      this._postConstruct = [];
    }
    this._postConstruct.push(postConstruct);
  }

  public get preDestroy(): string[] {
      return this._preDestroy;
  }

  public addPreDestroy(preDestroy: string): void {
    if (null == this._preDestroy) {
      this._preDestroy = [];
    }
    this._preDestroy.push(preDestroy);
  }

}

export default PouchDefinition;
