import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';

const PostConstruct = (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
  if (Reflect.hasOwnMetadata(METADATA.POUCH_DEFINITION, target) !== true) {
    throw new Error('Cannot apply @PostConstruct decorator on the not @Injectable class.');
  }
  let pouchDefinition: PouchDefinition = Reflect.getMetadata(METADATA.POUCH_DEFINITION, target);
  pouchDefinition.addPostConstruct(propertyKey);

  return descriptor;
};

export default PostConstruct;
