import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';

const PreDestroy = (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
  if (Reflect.hasOwnMetadata(METADATA.POUCH_DEFINITION, target) !== true) {
    throw new Error('Cannot apply @PreDestroy decorator on the not @Injectable class.');
  }
  let pouchDefinition: PouchDefinition = Reflect.getMetadata(METADATA.POUCH_DEFINITION, target);
  pouchDefinition.addPreDestroy(propertyKey);

  return descriptor;
};

export default PreDestroy;
