
import { SagaIterator } from 'redux-saga';
import { call, fork, take } from 'redux-saga/effects';

import * as LifecycleActions from '../action/lifecycle';

import AppContext from '../../AppContext';


function _destroy(): Promise<void> {
  return new Promise(resolve => {
    AppContext.getInstance().destroy();
    resolve();
  });
}

function* destroy(): SagaIterator {
  yield take(LifecycleActions.WILL_DESTROY);
  yield call(_destroy);
}


export default function* root(): SagaIterator {
  yield fork(destroy);
}
