import { connect, Dispatch } from 'react-redux';
import {
  InfraDetail,
  StateProps as InfraDetailStateProps,
  DispatchProps as InfraDetailDispatchProps,
} from './components/InfraDetail';

import MetaInfraType from '@overflow/meta/api/model/MetaInfraType';
import * as ReadByChildActions from '../redux/action/read_by_child';

export function mapStateToProps(state: any, props: any): InfraDetailStateProps {
  return {
    target: props.target,
    infra: props.infra,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): InfraDetailDispatchProps {
  return {
    onGetChildInfra: (type: MetaInfraType, id: number) => {
      dispatch(ReadByChildActions.request(type, id));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(InfraDetail);
