import Action from '@overflow/commons/redux/Action';
import Infra from '../..//api/model/Infra';

import ReadByChildPayload from '../payload/ReadByChildPayload';

import MetaInfraType from '@overflow/meta/api/model/MetaInfraType';

// Action Type
export type REQUEST = '@overflow/infra/read_by_child/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/read_by_child/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/read_by_child/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/read_by_child/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/read_by_child/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/read_by_child/REQUEST_FAILURE';

// Action Creater
export type request = (metaInfraType: MetaInfraType, id: number) => Action<ReadByChildPayload>;
export type requestSuccess = (infra: Infra) => Action<Infra>;
export type requestFailure = (error: Error) => Action;



export const request: request = (metaInfraType: MetaInfraType, id: number): Action<ReadByChildPayload> => {
  return {
      type: REQUEST,
      payload: {
        metaInfraType: metaInfraType,
        id: id,
      },
    };
};

export const requestSuccess: requestSuccess = (infra: Infra): Action<Infra> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infra,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
