import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraHost from '../../api/model/InfraHost';
import InfraHostService from '../../api/service/InfraHostService';
import * as ReadActions from '../action/host_read';
import HostReadPayload from '../payload/HostReadPayload';

function* read(action: Action<HostReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraHostService = AppContext.getInstance().getPouch(InfraHostService);
    const retApikey = yield call({context: infraHostService, fn: infraHostService.read}, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchHostRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
