import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraOSDaemon from '../../api/model/InfraOSDaemon';
import InfraOSDaemonService from '../../api/service/InfraOSDaemonService';
import * as RegistActions from '../action/os_daemon_regist';
import OSDaemonRegistPayload from '../payload/OSDaemonRegistPayload';

function* regist(action: Action<OSDaemonRegistPayload>): SagaIterator {
  try {
    const {infraOSDaemon} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraOSDaemonService = AppContext.getInstance().getPouch(InfraOSDaemonService);
    const retApikey = yield call({context: infraOSDaemonService, fn: infraOSDaemonService.regist}, infraOSDaemon);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSDaemonRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
