import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraOSPort from '../../api/model/InfraOSPort';
import InfraOSPortService from '../../api/service/InfraOSPortService';
import * as ReadActions from '../action/os_port_read';
import OSPortReadPayload from '../payload/OSPortReadPayload';

function* read(action: Action<OSPortReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraOSPortService = AppContext.getInstance().getPouch(InfraOSPortService);
    const retApikey = yield call({context: infraOSPortService, fn: infraOSPortService.read}, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSPortRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
