import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraOS from '../../api/model/InfraOS';
import InfraOSService from '../../api/service/InfraOSService';
import * as RegistActions from '../action/os_regist';
import OSRegistPayload from '../payload/OSRegistPayload';

function* regist(action: Action<OSRegistPayload>): SagaIterator {
  try {
    const {infraOS} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraOSService = AppContext.getInstance().getPouch(InfraOSService);
    const retApikey = yield call({context: infraOSService, fn: infraOSService.regist}, infraOS);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
