import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import Infra from '../../api/model/Infra';
import InfraService from '../../api/service/InfraService';
import * as ReadActions from '../action/os_read';
import ReadPayload from '../payload/ReadPayload';

function* read(action: Action<ReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraService = AppContext.getInstance().getPouch(InfraService);
    const retApikey = yield call({context: infraService, fn: infraService.read}, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
