import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraService from '../../api/model/InfraService';
import InfraServiceService from '../../api/service/InfraServiceService';
import * as RegistActions from '../action/service_regist';
import ServiceRegistPayload from '../payload/ServiceRegistPayload';

function* regist(action: Action<ServiceRegistPayload>): SagaIterator {
  try {
    const {infraService} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraServiceService = AppContext.getInstance().getPouch(InfraServiceService);
    const retApikey = yield call({context: infraServiceService, fn: infraServiceService.regist}, infraService);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchServiceRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
