
import Service from '@overflow/commons/api/Service';
import Sensor from '../model/Sensor';
import Target from '@overflow/target/api/model/Target';
import Probe from '@overflow/probe/api/model/Probe';
import Domain from '@overflow/domain/api/model/Domain';

export class SensorService extends Service {

  public constructor() {
    super('SensorService');
  }

  public regist(sensor:Sensor): Promise<Sensor> {
    return this.send<Sensor>('regist', [sensor]);
  }

  public readAllByTarget(target:Target): Promise<Sensor[]> {
    return this.send<Sensor[]>('readAllByTarget', [target]);
  }

  public readAllByProbe(probe: Probe): Promise<Sensor[]> {
    return this.send<Sensor[]>('readAllByProbe', [probe]);
  }

  public readAllByDomain(domain: Domain): Promise<Sensor[]> {
    return this.send<Sensor[]>('readAllByDomain', [domain]);
  }

  public read(id:number): Promise<Sensor> {
    return null;
  }

  public remove(sensor:Sensor): Promise<Sensor> {
    return null;
  }

  public start(sensor:Sensor): Promise<Sensor> {
    return null;
  }

  public stop(sensor:Sensor): Promise<Sensor> {
    return null;
  }
}

export default SensorService;
