import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import Sensor from '../../api/model/Sensor';
import SensorService from '../../api/service/SensorService';
import * as ReadAllByDomainActions from '../action/read_all_by_domain';
import ReadAllByDomainPayload from '../payload/ReadAllByDomainPayload';

function* readAllByDomain(action: Action<ReadAllByDomainPayload>): SagaIterator {
  try {
    const {domain} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let sensorService = AppContext.getInstance().getPouch(SensorService);
    const ret = yield call({context: sensorService, fn: sensorService.readAllByDomain}, domain);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadAllByDomainActions.requestSuccess(ret));
  } catch (e) {
    yield put(ReadAllByDomainActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadAllByTarget(): SagaIterator {
  yield takeLatest(ReadAllByDomainActions.REQUEST, readAllByDomain);
}
